﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Markup;
using System.Collections;
using System.Collections.ObjectModel;
using Telerik.Windows.Controls;
using System.Windows.Automation;

namespace TreeViewIsCheckedSync
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>
	public partial class Window1 : Window
	{
		public static OrganisationViewModel GetTopOrganisation(string name)
		{
			return new OrganisationViewModel()
			{
				OrganisationName = String.Format("Top Organisation {0}", name),
				Children = new ObservableCollection<object>()
				{ 
					new PersonViewModel(){ Name = String.Format("Person1 {0}",name) },
					new OrganisationViewModel()
					{ 
						OrganisationName = String.Format("Organisation 1.1 {0}",name),
						Children = new ObservableCollection<object>()
						{
							new OrganisationViewModel()
							{
								OrganisationName = String.Format("Organisation 2.1 {0}",name),
								Children = new ObservableCollection<object>()
								{
									new OrganisationViewModel()
									{
										OrganisationName = String.Format("Organisation 3.1 {0}",name)
									}
								}
							},
							new PersonViewModel(){ Name = String.Format("Person 1.1 {0}",name) },
							new PersonViewModel(){ Name = String.Format("Person 1.2 {0}",name) }
						}
					}
				}
			};
		}

		public Window1()
		{
			InitializeComponent();

			treeView.ItemsSource = new object[] { GetTopOrganisation("A") };
		}
	}

	public class OrganisationTemplateSelector : DataTemplateSelector
	{
		public override DataTemplate SelectTemplate(object item, DependencyObject container)
		{
			if (item is PersonViewModel)
			{
				return this.Person;
			}
			else if (item is OrganisationViewModel)
			{
				return this.Organisation;
			}
			return null;
		}

		public DataTemplate Person
		{
			get;
			set;
		}

		public DataTemplate Organisation
		{
			get;
			set;
		}
	}

	public class PersonViewModel
	{
		public String Name { get; set; }

		public override string ToString()
		{
			return Name;
		}

		public bool? IsChecked { get; set; }
	}

	//public class CheckedToBoolConverter : IValueConverter
	//{
	//    public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
	//    {
	//        var isChecked = value as bool?;
	//        if (isChecked != null && isChecked.HasValue)
	//        {
	//            return isChecked.Value ? ToggleState.On : ToggleState.Off;
	//        }
	//        return ToggleState.Indeterminate;
	//    }

	//    public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
	//    {
	//        var isChecked = (ToggleState)value;
	//        switch (isChecked)
	//        {
	//            case ToggleState.Indeterminate:
	//                return null;
	//                break;
	//            case ToggleState.Off:
	//                return false;
	//                break;
	//            case ToggleState.On:
	//                return true;
	//                break;
	//            default:
	//                return null;
	//        }
	//    }
	//}


	public class OrganisationViewModel
	{
		public OrganisationViewModel()
		{
			Children = new ObservableCollection<Object>();
		}
		public String OrganisationName { get; set; }
		public IList<Object> Children { get; set; }

		public override string ToString()
		{
			return OrganisationName;
		}

		public bool? IsChecked { get; set; }
	}
}
